﻿package de.davidochmann.frameworks.dosite.main.data 
{
	/**
	 * @author David Ochmann
	 */

	import de.davidochmann.frameworks.dosite.main.data.composition.Composition;
	import de.davidochmann.frameworks.dosite.main.data.content.Content;
	
	public class Data 
	{
		private static var mInstance:Data;
		
		private var mContent:Content;
		private var mComposition:Composition;

		
		
		public function Data(pSingletonEnforcer:SingletonEnforcer){}
		
		public static function getInstance():Data
		{
			if(Data.mInstance == null) mInstance = new Data(new SingletonEnforcer());
			return mInstance;
		}
		
		public function init():void
		{
			initContent();
			initComposition();
		}
		
		
		
		/*
		 * PUBLIC FUNCTIONS
		 */
		 
		public function content():Content
		{
			return mContent;
		}
		
		public function composition():Composition
		{
			return mComposition;
		}

		
		
		
		/*
		 * PRIVATE FUNCTIONS
		 */
		 
		private function initContent():void
		{
			mContent = new Content();
		}
		
		private function initComposition():void
		{
			mComposition = new Composition();
		}		
	}
}

class SingletonEnforcer{}