﻿package de.davidochmann.frameworks.dosite.main.contentinitializer 
{
	/**
	 * @author dochmann
	 */

	import flash.net.URLRequest;
	import flash.display.Loader;
	import flash.display.DisplayObject;
	import de.davidochmann.frameworks.dosite.main.displayregister.DisplayRegister;
	import de.davidochmann.frameworks.dosite.main.containerbuilder.containerfactory.container.SubsiteContainer;
	import de.davidochmann.frameworks.dosite.main.containerbuilder.containerfactory.container.FixedContainer;

	public class ContentInitializer 
	{
		private var mDisplayRegister:DisplayRegister;


		
		public function ContentInitializer(pDisplayRegister:DisplayRegister):void
		{
			setDisplayRegister(pDisplayRegister);
		}
		
		
		
		/*
		 * PUBLIC FUNCTIONS
		 */
		
		public function initialize():void
		{
			initDisplayObjects();
		}
		
		public function initSubsite(pSubsiteContainer:SubsiteContainer):void
		{
			var sc:SubsiteContainer	= pSubsiteContainer;
			var child:DisplayObject = sc.getChild();
			var path:String			= sc.getPath(); 
				
			var urlRequest:URLRequest;
			var loader:Loader;
			
			sc.x = sc.getX();
			sc.y = sc.getY();
			
			if(child != null) sc.addChild(child);
			else if(path != null && path != "")
			{
				urlRequest = new URLRequest(path);
				loader     = new Loader();
				
				loader.load(urlRequest);
				sc.addChild(loader);
			} 
		}

		public function initContainer(pContainerContainer:FixedContainer):void
		{
			var cc:FixedContainer	= pContainerContainer;
			var child:DisplayObject = cc.getChild();
			var path:String			= cc.getPath(); 
				
			var urlRequest:URLRequest;
			var loader:Loader;
			
			cc.x = cc.getX();
			cc.y = cc.getY();
			
			if(child != null) cc.addChild(child);
			else
			{
				urlRequest = new URLRequest(path);
				loader     = new Loader();
				
				loader.load(urlRequest);
				cc.addChild(loader);
			} 
		}
		
		
		
		/*
		 * GETTER FUNCTIONS
		 */
		
		public function getDisplayRegister():DisplayRegister
		{
			return mDisplayRegister;
		}

		
		
		/*
		 * SETTER FUNCTIONS
		 */
		
		public function setDisplayRegister(pDisplayRegister:DisplayRegister):void
		{
			mDisplayRegister = pDisplayRegister;
		}

		
		
		/*
		 * PRIVATE FUNCTIONS
		 */

		private function initDisplayObjects():void
		{
			var conList:Array = mDisplayRegister.containerContainerList();
			var subList:Array = mDisplayRegister.subsiteContainerList();
			
			var clength:uint = conList.length;
			var slength:uint = subList.length;
			
			var container:FixedContainer;
			var subsite:SubsiteContainer;
			
			var child:DisplayObject;
			var path:String; 			
			
			var urlRequest:URLRequest;
			var loader:Loader;
			
			
			for(var i:uint = 0; i < slength; ++i)
			{
				path	      = null;
				urlRequest	  = null;
				loader		  = null;
				
				subsite       = SubsiteContainer(subList[i]);
				
				child	  	  = subsite.getChild();
				path	  	  = subsite.getPath();
				
				subsite.x 	  = subsite.getX();
				subsite.y	  = subsite.getY();
				
				if(child != null) subsite.addChild(child);
				else
				{
					urlRequest = new URLRequest(path);
					loader     = new Loader();
					
					subsite.addChild(loader);
					loader.load(urlRequest);					
				} 
			}
			
			for(var j:uint = 0; j < clength; ++j)
			{
				path		  = null;
				urlRequest	  = null;
				loader		  = null;
				
				container  	  = FixedContainer(conList[j]);
								
				child		  = container.getChild();
				path		  = container.getPath();
				
				container.x	  = container.getX();
				container.y	  = container.getY();
								
				if(child != null) container.addChild(child);
				else
				{
					urlRequest = new URLRequest(path);
					loader     = new Loader();
					
					loader.load(urlRequest);
					container.addChild(loader);
				} 					
			}
		}
	}
}
