﻿package de.davidochmann.frameworks.dosite.main.displayregister 
{
	/**
	 * @author dochmann
	 */

	import de.davidochmann.frameworks.dosite.main.containerbuilder.containerfactory.container.SubsiteContainer;
	import de.davidochmann.frameworks.dosite.main.containerbuilder.containerfactory.container.FixedContainer;
	
	public class DisplayRegister 
	{
		private var mSubsiteContainerList:Array;
		private var mContainerContainerList:Array;
		
		
		
		public function DisplayRegister():void
		{
			initSubsiteContainerList();
			initContainerContainerList();
		}



		/*
		 * PUBLIC FUNCTIONS
		 */

		public function subsiteContainer(pId:String):SubsiteContainer
		{
			var subsiteContainer:SubsiteContainer;
			var length:uint = mSubsiteContainerList.length;
			
			for(var i:uint = 0; i < length; ++i)
			{
				subsiteContainer = SubsiteContainer(mSubsiteContainerList[i]);
				if(subsiteContainer.getId() == pId) break;
				subsiteContainer = null;
			}
			
			return subsiteContainer;
		}

		public function fixedContainer(pId:String):FixedContainer
		{
			var containerContainer:FixedContainer;
			var length:uint = mContainerContainerList.length;
			
			for(var i:uint = 0; i < length; ++i)
			{
				containerContainer = FixedContainer(mContainerContainerList[i]);
				if(containerContainer.getId() == pId) break;
				containerContainer = null;
			}
			
			return containerContainer;
		}

		public function subsiteContainerList():Array
		{
			return  mSubsiteContainerList;
		}

		public function containerContainerList():Array
		{
			return mContainerContainerList;
		}

		public function addSubsite(pSubsiteContainer:SubsiteContainer):void
		{
			mSubsiteContainerList.push(pSubsiteContainer);	
		}
	
		public function addContainer(pContainerContainer:FixedContainer):void
		{
			mContainerContainerList.push(pContainerContainer);
		}


		
		/*
		 * PRIVATE FUNCTIONS
		 */

		private function initSubsiteContainerList():void
		{
			mSubsiteContainerList = new Array();
		}

		private function initContainerContainerList():void
		{
			mContainerContainerList = new Array();
		}
	}
}
