﻿package de.davidochmann.frameworks.dosite.main.xmlparser.data.composition.item.layout 
{
	/**
	 * @author dochmann
	 */

	import de.davidochmann.frameworks.dosite.main.xmlparser.data.composition.item.layout.item.Fixed;
	import de.davidochmann.frameworks.dosite.main.xmlparser.data.composition.item.layout.item.Subsite;
	 
	public class Layout 
	{
		private var mSubsiteList:Array;
		private var mFixedList:Array;
		
		
		
		public function Layout():void
		{
			initSubsiteList();
			initFixedList();
		}	


		
		/*
		 * PUBLIC FUNCTIONS
		 */
		
		public function subsite(pId:String):Subsite
		{
			var subsite:Subsite;
			var length:uint = mSubsiteList.length;
			
			for(var i:uint = 0; i < length; ++i)
			{
				subsite = Subsite(mSubsiteList[i]);
				if(subsite.getId() == pId) break;	
				subsite = null;			
			}
			
			return subsite;
		}

		public function fixed(pId:String):Fixed
		{
			var fixed:Fixed;
			var length:uint = mFixedList.length;
			
			for(var i:uint = 0; i < length; ++i)
			{
				fixed = Fixed(mFixedList[i]);
				if(fixed.getId() == pId) break;
				fixed = null;
			}
			
			return fixed;
		}

		public function subsiteAt(pIndex:uint):Subsite
		{
			return Subsite(mSubsiteList[pIndex]);
		}

		public function fixedAt(pIndex:uint):Fixed
		{
			return Fixed(mFixedList[pIndex]);
		}

		public function subsiteList():Array
		{
			return mSubsiteList;
		}

		public function fixedList():Array
		{
			return mFixedList;
		}

		public function addSubsite(pSubsite:Subsite):void
		{
			mSubsiteList.push(pSubsite);			
		}

		public function addFixed(pFixed:Fixed):void
		{
			mFixedList.push(pFixed);
		}

		
		
		/*
		 * PRIVATE FUNCTIONS
		 */
		 
		private function initSubsiteList():void
		{
			mSubsiteList = new Array();
		}
		
		private function initFixedList():void
		{
			mFixedList = new Array();
		}
	}
}
