﻿package de.davidochmann.frameworks.dosite.main.xmlparser.data.content 
{
	/**
	 * @author dochmann
	 */

	import de.davidochmann.frameworks.dosite.main.xmlparser.data.content.item.Graphic;
	import de.davidochmann.frameworks.dosite.main.xmlparser.data.content.item.Extensible;
	 
	public class Content 
	{
		private var mExtensibleList:Array;
		private var mGraphicList:Array;
		
		
		
		public function Content():void
		{
			initExtensibleList();
			initGraphicList();
		}


		
		/*
		 * PUBLIC FUNCTIONS
		 */
				
		public function extensible(pId:String):Extensible
		{
			var extensible:Extensible;
			var length:uint = mExtensibleList.length;
			
			for(var i:uint = 0; i < length; ++i)
			{
				extensible = Extensible(mExtensibleList[i]);
				if(extensible.getId() == pId) break;
				extensible = null; 		
			}

			return extensible;
		}

		public function graphic(pId:String):Graphic
		{
			var graphic:Graphic;
			var length:uint = mGraphicList.length;
			
			for(var i:uint = 0; i < length; ++i)
			{
				graphic = Graphic(mGraphicList[i]);
				if(graphic.getId() == pId) break;
				graphic = null;
			}
			
			return graphic;
		}

		public function extensibleAt(pIndex:uint):Extensible
		{
			return Extensible(mExtensibleList[pIndex]);
		}

		public function graphicAt(pIndex:uint):Graphic
		{
			return Graphic(mGraphicList[pIndex]);
		}

		public function extensibleList():Array
		{
			return mExtensibleList;
		}

		public function graphicList():Array
		{
			return mGraphicList;
		}

		public function addExtensible(pExtensible:Extensible):void
		{
			mExtensibleList.push(pExtensible);			
		}

		public function addGraphics(pGraphic:Graphic):void
		{
			mGraphicList.push(pGraphic);
		}

		
		
		/*
		 * PRIVATE FUNCTIONS
		 */

		private function initExtensibleList():void
		{
			mExtensibleList = new Array();
		}

		private function initGraphicList():void
		{
			mGraphicList = new Array();
		}
	}
}
