﻿package de.davidochmann.projects.vivaespana 
{
	/**
	 * @author David Ochmann
	 */
	import de.davidochmann.frameworks.dosite.DoSite;
	import de.davidochmann.frameworks.dosite.main.containerbuilder.containerfactory.container.FixedContainer;
	import de.davidochmann.frameworks.dosite.main.containerbuilder.containerfactory.container.SubsiteContainer;
	import de.davidochmann.frameworks.dosite.main.events.DoSiteEvent;

	import de.davidochmann.projects.vivaespana.content.scroller.Scroller;
	import de.davidochmann.projects.vivaespana.fixed.header.Header;
	import de.davidochmann.projects.vivaespana.fixed.menu.Menu;
	import de.davidochmann.projects.vivaespana.subsite.aktionen.Aktionen;
	import de.davidochmann.projects.vivaespana.subsite.anfahrt.Anfahrt;
	import de.davidochmann.projects.vivaespana.subsite.home.Home;
	import de.davidochmann.projects.vivaespana.subsite.kulinarische.Kulinarische;
	import de.davidochmann.projects.vivaespana.subsite.restaurant.Restaurant;
	import de.davidochmann.projects.vivaespana.subsite.rezepte.Rezepte;

	import com.greensock.TweenMax;
	import com.greensock.easing.Strong;

	import flash.display.Sprite;
	//	import flash.external.ExternalInterface;

	public class VivaEspana extends Sprite 
	{
		private var mDoSite:DoSite;
		
		private var mHeader:Header;
		private var mMenu:Menu;
		private var mHome:Home;
		private var mRestaurant:Restaurant;
		private var mKulinarische:Kulinarische;
		private var mAktionen:Aktionen;
		private var mRezepte:Rezepte;
		private var mAnfahrt:Anfahrt;
		
		private var mFixedHeader:FixedContainer;
		private var mFixedMenu:FixedContainer;
		
		private var mSubsiteHome:SubsiteContainer;
		private var mSubsiteRestaurant:SubsiteContainer;
		private var mSubsiteKulinarische:SubsiteContainer;
		private var mSubsiteAktionen:SubsiteContainer;
		private var mSubsiteRezepte:SubsiteContainer;
		private var mSubsiteAnfahrt:SubsiteContainer;

		private var mScroller:Scroller;
		
		
		
		public function VivaEspana()
		{
			initHeader();
			initMenu();
			initHome();		
			initRestaurant();
			initKulinarische();
			initAktionen();
			initRezepte();
			initAnfahrt();
			initDoSite();
			initScroller();
		}
		

		
		/*
		 * PRIVATE FUNCTIONS
		 */
				
		private function initHeader():void
		{
			mHeader = new Header();
		}
		
		private function initMenu():void
		{
			mMenu = new Menu();
		}
		
		private function initHome():void
		{
			mHome = new Home();
		}
		
		private function initRestaurant():void
		{
			mRestaurant = new Restaurant();
		}
		
		private function initKulinarische():void
		{
			mKulinarische = new Kulinarische();
		}
		
		private function initAktionen():void
		{
			mAktionen = new Aktionen();
		}
		
		private function initRezepte():void
		{
			mRezepte = new Rezepte();
		}

		private function initAnfahrt():void
		{
			mAnfahrt = new Anfahrt();
		}
		
		private function initDoSite():void
		{
			mDoSite = DoSite.getInstance();
			
			var content:XML		=	<DATA>
									
										<CONTENT>		
											<EXTENSIBLE></EXTENSIBLE>
											<GRAPHIC></GRAPHIC>
										</CONTENT>

									</DATA>;
								
			var composition:XML = 	<DATA>
									
										<COMPOSITION>
											<SETUP init="home" position="tc" />
											<TRANSITION swap="800" wait="true" />
									
											<LAYOUT>
												<FIXED></FIXED>
												<SUBSITE></SUBSITE>
											</LAYOUT>
											
										</COMPOSITION>
											     
									</DATA>;
			
			mDoSite.addEventListener(DoSiteEvent.NAVIGATION_SITE_OPEN, doSiteNavigationSiteOpenHandler);	
			mDoSite.addEventListener(DoSiteEvent.NAVIGATION_SITE_SWAP_INIT, doSiteNavigationSiteSwapInitHandler);
			mDoSite.addEventListener(DoSiteEvent.NAVIGATION_SITE_SWAP_OPEN, doSiteNavigationSiteSwapOpenHandler);

			mDoSite.initialize(content, composition);
			
			mFixedHeader 		 = new FixedContainer("01","header", "", "", mHeader, -485,   0, 950, 310, 0);
			mFixedMenu	 		 = new FixedContainer("02",  "menu", "", "",   mMenu, -485, 300, 950,  60, 1);
			
			mSubsiteHome 	   	 = new SubsiteContainer("03",   	  "home", 		  "home", "", "",	      mHome, -485, 360, 950,  465);
			mSubsiteRestaurant 	 = new SubsiteContainer("04",   "restaurant",	"restaurant", "", "",   mRestaurant, -485, 360, 950,  395);
			mSubsiteKulinarische = new SubsiteContainer("04", "kulinarische", "kulinarische", "", "", mKulinarische, -485, 360, 950, 1030);
			mSubsiteAktionen 	 = new SubsiteContainer("05", 	  "aktionen", 	  "aktionen", "", "", 	  mAktionen, -485, 360, 950,  465);
			mSubsiteRezepte 	 = new SubsiteContainer("06", 	   "rezepte", 	   "rezepte", "", "", 	   mRezepte, -485, 360, 950, 1065);
			mSubsiteAnfahrt		 = new SubsiteContainer("07", 	   "anfahrt", 	   "anfahrt", "", "", 	   mAnfahrt, -485, 360, 950,  465);
			
			mDoSite.addFixed(mFixedHeader);
			mDoSite.addFixed(mFixedMenu);
			
			mDoSite.addSubsite(mSubsiteHome);
			mDoSite.addSubsite(mSubsiteRestaurant);
			mDoSite.addSubsite(mSubsiteKulinarische);
			mDoSite.addSubsite(mSubsiteAktionen);
			mDoSite.addSubsite(mSubsiteRezepte);
			mDoSite.addSubsite(mSubsiteAnfahrt);
						
			mDoSite.start();
						
			addChild(mDoSite.container());
		}
		
		private function doSiteNavigationSiteOpenHandler(e:DoSiteEvent):void
		{
			var sub:SubsiteContainer = SubsiteContainer(e.getSubsiteContainer());
			
			sub.filters = null;
			sub.y		= sub.getY();
			
//			ExternalInterface.call("resize", sub.getHeight() + sub.getY() + 9);
		}

		private function doSiteNavigationSiteSwapInitHandler(e:DoSiteEvent):void
		{
			var sub:SubsiteContainer = SubsiteContainer(e.getSubsiteContainer());
			var pos:int = sub.getY() - sub.getHeight() + 25;
				
			TweenMax.to(sub, .8, {y:pos, ease:Strong.easeInOut});
		}

		private function doSiteNavigationSiteSwapOpenHandler(e:DoSiteEvent):void
		{
			var sub:SubsiteContainer = SubsiteContainer(e.getSubsiteContainer());
			var pos:int  = sub.getY();
			
			sub.y = sub.getY() - sub.getHeight() + 25;
			
			TweenMax.to(sub, .8, {y:pos, blurFilter:{blurY:0}, onComplete:mScroller.checkNeed, ease:Strong.easeInOut});
			
//			ExternalInterface.call("resize", sub.getHeight() + sub.getY() + 9);
		}

		private function initScroller():void
		{
			mScroller = new Scroller(stage, mDoSite.container());
			addChild(mScroller);
		}	
	}
}
