﻿package de.davidochmann.projects.vivaespana.fixed.menu 
{
	/**
	 * @author David Ochmann
	 */
	 
	import de.davidochmann.frameworks.dosite.main.containerbuilder.containerfactory.container.SubsiteContainer;
	import de.davidochmann.frameworks.dosite.main.events.DoSiteEvent;
	import de.davidochmann.frameworks.dosite.DoSite;
	import com.greensock.easing.Strong;
	import com.greensock.TweenMax;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.display.MovieClip;
	import de.davidochmann.projects.vivaespana.fixed.menu.button.Button;

	[Embed (source="../../../../../../../deploy/swf/fixed/menu.swf", symbol="menu")]
	 
	public class Menu extends MovieClip 
	{
		public var mButton1:Button;
		public var mButton2:Button;
		public var mButton3:Button;
		public var mButton4:Button;
		public var mButton5:Button;
		public var mButton6:Button;
		
		private var mDoSite:DoSite;
		private var mButtonList:Array;
		
		
		
		public function Menu()
		{
			initDoSite();
			initButtonList();
			initButtons();
			initDoSiteEvents();
		}
		
		
		
		/*
		 * PRIVATE FUNCTIONS
		 */
		
		private function initDoSite():void
		{
			mDoSite = DoSite.getInstance();
		}
		
		
		private function initButtonList():void
		{
			mButtonList = [{btn:mButton1, tyn:24, tya:19, url:"home", txt:"Home"},
						   {btn:mButton2, tyn:24, tya:19, url:"restaurant", txt:"Das Restaurant"},
						   {btn:mButton3, tyn:14, tya: 9, url:"kulinarische", txt:"Kulinarische\nSpezialitäten"},
						   {btn:mButton4, tyn:24, tya:19, url:"aktionen", txt:"Aktionen"},
						   {btn:mButton5, tyn:24, tya:19, url:"rezepte", txt:"Rezepte"},
						   {btn:mButton6, tyn:24, tya:19, url:"anfahrt", txt:"Anfahrt"}];
		}
		
		
		private function initButtons():void
		{
			var obj:Object;
			var btn:Button;
			var tyn:int;
			var txt:String;
			
			var txf:TextField;
			var msk:MovieClip;
			
			var bll:uint = mButtonList.length;
			
			for(var i:uint = 0; i < bll; ++i)
			{
				obj = Object(mButtonList[i]);
				btn = Button(obj.btn);
				tyn = obj.tyn;
				txt = obj.txt;
				
				txf = btn.mButtonText;
				msk = btn.mButtonMask;
				
				txf.y = tyn;
				txf.text = txt;
				msk.y = 10;
				
				btn.buttonMode = true;
				btn.mouseChildren = false;
				
				btn.addEventListener(MouseEvent.MOUSE_UP, buttonMouseUpHandler);
				btn.addEventListener(MouseEvent.ROLL_OVER, buttonRollOverHandler);
				btn.addEventListener(MouseEvent.ROLL_OUT, buttonRollOutHandler);
			}
		}

		private function buttonMouseUpHandler(e:MouseEvent):void
		{
			var obj:Object;
			var btn:Button; 
			
			var btt:Button = Button(e.currentTarget);
			var bll:uint   = mButtonList.length;
			
			for(var i:uint = 0; i < bll; ++i)
			{
				obj = Object(mButtonList[i]);
				btn = Button(obj.btn);
				
				if(btt == btn)
				{
					mDoSite.swap(obj.url);
					break;	
				}
			}
		}

		private function buttonRollOverHandler(e:MouseEvent):void
		{
			var txf:TextField = TextField(Button(e.currentTarget).mButtonText);
			TweenMax.to(txf, .6, {tint:0xE0740A, ease:Strong.easeOut});
		}
		
		private function buttonRollOutHandler(e:MouseEvent):void
		{
			var txf:TextField = TextField(Button(e.currentTarget).mButtonText);
			TweenMax.to(txf, .6, {removeTint:true, ease:Strong.easeOut});
		}
		
		
		private function initDoSiteEvents():void
		{
			mDoSite.addEventListener(DoSiteEvent.NAVIGATION_SITE_OPEN, NavigationSiteOpenHandler);
			mDoSite.addEventListener(DoSiteEvent.NAVIGATION_SITE_SWAP_OPEN, NavigationSiteSwapOpenHandler);	
		}
		
		private function NavigationSiteOpenHandler(e:DoSiteEvent):void
		{
			var url:String = String(SubsiteContainer(e.getSubsiteContainer()).getURL());
			open(url);
		}

		private function NavigationSiteSwapOpenHandler(e:DoSiteEvent):void
		{
			var url:String = String(SubsiteContainer(e.getSubsiteContainer()).getURL());
			open(url);
		}

		
		
		/*
		 * OPEN FUNCTION
		 */
		 
		private function open(pUrl:String):void
		{
			var obj:Object;
			var url:String;		
			var btt:Button;
			
			var bll:uint = mButtonList.length;
			
			for(var i:uint = 0; i < bll; ++i)
			{
				obj = Object(mButtonList[i]);
				url = String(obj.url);
				
				if(pUrl == url)
				{
					btt = Button(obj.btn);
					break;
				}
			}
			
			var btn:Button;
			var msk:MovieClip;
			var txf:TextField;
			var tyn:int;
			var tya:int;
			
			for(var j:uint = 0; j < bll; ++j)
			{
				obj = Object(mButtonList[j]);
				btn = Button(obj.btn);
				txf = TextField(btn.mButtonText);
				msk = MovieClip(btn.mButtonMask);
				tyn = int(obj.tyn);
				tya = int(obj.tya);
				
				if(btt == btn)
				{
					TweenMax.to(msk, .4, {y:  0, roundProps:["y"], ease:Strong.easeOut});
					TweenMax.to(txf, .4, {y:tya, roundProps:["y"], ease:Strong.easeOut});
				}
				else
				{
					TweenMax.to(msk, .4, {y: 10, roundProps:["y"], ease:Strong.easeOut});
					TweenMax.to(txf, .4, {y:tyn, roundProps:["y"], ease:Strong.easeOut});
				}
			}
		} 
	}
}
